///////////////////////////////////////
// Lecture: Hoisting


//calling before the function is defined in lexical scope 
//calculateAge(1995);

function calculateAge(year){
    console.log(2018 - year);
}

//after the function is defined 
//calculateAge(1995);


//calling before the function is defined in lexical scope 
//retirement(1995);  //--> results in an error being thrown and says retirement isn't a runction 

//function expressions
var retirement = function(year){
    console.log(65-(2018 - year) + ' years before retirement.');
}

//after the function is defined 
//retirement(1995);


// the above code is an example of hoisting, in the creation phase of the EC the function declaration calculateAge is stored in the variable object, and even before the code is executed.  Once we enter Execution Phase the CalculateAge function is ready for us to be used 

// the reason the calculateAge function can be accessed before/after it is defined is because it is a function declaration.  Function expressions can only be accessed after they have been defined 


//variables - thanks to hoisting Variables are set to undefined in the creation phase 
//console.log(age); //this is a function declaration 
var age = 23; //-> store in the Global EC - it is in the VO of the Global EC object

function foo() { // also store in global EC obj 
    console.log(age);
    var age = 65; //-> this age variable is defined in the foo EC obj
    console.log(age); 
}

//foo();
//console.log(age);


// Most Important Use Case for Hoisting: the fact that we can use function declarations before we actually declare them in our code, not necessarily the variables thing.  



///////////////////////////////////////
// Lecture: Scoping


// First scoping example

/*
var a = 'Hello!';
first();

function first() {
    var b = 'Hi!';
    second();

    function second() {
        var c = 'Hey!';
        console.log(a + b + c);
    }
}
*/



// Example to show the differece between execution stack and scope chain

/*
var a = 'Hello!';
first();

function first() {
    var b = 'Hi!';
    second();

    function second() {
        var c = 'Hey!';
        third()
    }
}

function third() {
    var d = 'John';
    console.log(a + b + c + d);
}
*/



///////////////////////////////////////
// Lecture: The this keyword

//In a regular function call the 'this' keyword always points to the window object -> 
    //because -> the object that this function is attached to is the global object 

//console.log(this);

//calculateAge(1995);
//function calculateAge(year){
//    console.log(2018 - year);
//    console.log(this);
//}
// window {...}


//with a method call we can change what 'this' is pointing to 
var john = {
    name: 'John',
    yearOfBirth: 1990,
    calculateAge: function (){
        console.log(this); 
        console.log(2018 - this.yearOfBirth);
        
//        function innerFunction() {
//            console.log(this); // Q1: why does the 'this' keyword here return the window object? 
//        }
//        
//        innerFunction();
    }
}
john.calculateAge();
// {name: "John", yearOfBirth: 1990, calculateAge: ƒ}

//method borrowing - borrow john's method to use it on mike
var mike = {
    name: 'Mike',
    yearOfBirth: 1984,
    
}

mike.calculateAge = john.calculateAge; // no () needed because we aren't calling anything 
mike.calculateAge();
//34 .. Q2: how did we get that? 



// so this this on line 119 is pointing to john the john object- it is both in john's scope and it is called on the object -> not a constructor function so it won't be on John's prototype chain 


//Q1 ANS: because it was a regular function call, not a method call, calculateAge was the method- even though it's inside it's still a regular function.  

//Q2 ANS: the this variable is only assigned a value when the object calls a method... again... the this keyword inside of a method is only assigned a value when it is called and it is pointing at the object that called it.  