/*
GAME RULES:

- The game has 2 players, playing in rounds
- In each turn, a player rolls a dice as many times as he whishes. Each result get added to his ROUND score
- BUT, if the player rolls a 1, all his ROUND score gets lost. After that, it's the next player's turn
- The player can choose to 'Hold', which means that his ROUND score gets added to his GLBAL score. After that, it's the next player's turn
- The first player to reach 100 points on GLOBAL score wins the game

*/
var scores, roundScore, activePlayer, gamePlaying;

//using a Statevariable: 'gamePlaying'-> tells us the condidtion of the system
//is our game playing yes or no?


init();
console.log(gamePlaying);


// the event listener for the dice roll button 
document.querySelector('.btn-roll').addEventListener('click', function(){
    console.log(scores[activePlayer]);
    //state variable checker
    if(gamePlaying) {
            // 1. Random Number
        var dice = Math.floor(Math.random() *6) + 1;

        //2. Display the result
        var diceDOM = document.querySelector('.dice');
        diceDOM.style.display = 'block';
        diceDOM.src = 'dice-' + dice + '.png';

        //3. Update the round score IF the rolled number was NOT a 1
        if (dice !== 1) {
            //Add Score if anything but a 1 is rolled
            roundScore += dice;
            document.querySelector('#current-' + activePlayer).textContent = roundScore;
        } else {

    //****-> Using the DRY principle, the above code could be shortened to the function call on line 66 because we have now created a function nextPlayer that does that same thing 
            nextPlayer();//Lec #8

        }
    }  
    
});



// The event listener for the Hold Button '.btn-hold' 
document.querySelector('.btn-hold').addEventListener('click', function(){
    //state variable checker
    if(gamePlaying) {
        //Add Current score to GLOBAL score => (using the 'scores' array on the global object) 
        scores[activePlayer] += roundScore;

        // Update the UI, where are we writing our data to? => '#score-0', '#score-0'
        document.querySelector('#score-' + activePlayer).textContent = scores[activePlayer];
        console.log(scores[activePlayer]);

    // Check if the player won the game
        // We could actually just copy and paste the code from above but...
        //We use the Don't Repeat Yourself (DRY) Principle -> implement new function
        if(scores[activePlayer] >= 100) {
            document.querySelector('#name-' + activePlayer).textContent = 'Winner!';

            //Optional Feature: hide the 'roll' and 'hold' buttons when the game has been won
            document.querySelector('.btn-roll').style.display = 'none'; //Lec #8
            document.querySelector('.btn-hold').style.display = 'none';//Lec #8

            document.querySelector('.dice').style.display = 'none';//Lec #8

            //adjusting the player panels with the CSS class 'winner'
            document.querySelector('.player-'+activePlayer + '-panel').classList.add('winner');//Lec #8
            document.querySelector('.player-'+activePlayer + '-panel').classList.remove('active');//Lec #8

            //state variable changer
            gamePlaying = false;
        }else{
            nextPlayer();//Lec #8
        }//Lec #8
    }
    
    
    
    
});


//Creating this reusable function is an example of the DRY principle 
function nextPlayer(){
     // Next player: and delete round score if 1 is rolled 
        // using ternary operator _ ? _ : _ ; to decide the active player 
        activePlayer === 0 ? activePlayer = 1 : activePlayer = 0;
        roundScore = 0;
        
        //sets the 'current' id scores to 0 - as in their round score 
        document.getElementById('current-0').textContent = '0';
        document.getElementById('current-1').textContent = '0';
        
        
        //use classList.toggle() instead - it works like a light switch 
        document.querySelector('.player-0-panel').classList.toggle('active');
        document.querySelector('.player-1-panel').classList.toggle('active');
        
        
        // making the dice disappear after a 1 is rolled (only gone until the dice is rolled again though)
        document.querySelector('.dice').style.display = 'none';
    
}//Lec #8


//LECTURE 9 -- Initializtion function (or INIT for short)
document.querySelector('.btn-new').addEventListener('click', init);


function init(){
    scores = [0,0];
    roundScore = 0;
    activePlayer = 0;
    gamePlaying = true;
    
    //when the page loads the dice doesn't appear right away (until rolldice is pushed)
    document.querySelector('.dice').style.display = 'none';
    
    //specifically for the .btn-new class but makes sure these buttons are there when needed 
    document.querySelector('.btn-roll').style.display = 'initial'; 
    document.querySelector('.btn-hold').style.display = 'initial';

    // setting all scores to 0 when the program loads 
    document.getElementById('score-0').textContent = '0';
    document.getElementById('score-1').textContent = '0';
    document.getElementById('current-0').textContent = '0';
    document.getElementById('current-1').textContent = '0';
    
    //Set the names back (usually after a winner has occurred)
    document.getElementById('name-0').textContent = 'Player 1';
    document.getElementById('name-1').textContent = 'Player 2';
    
    //removing the CSS 'winner' class from the player panels
    document.querySelector('.player-0-panel').classList.remove('winner');
    document.querySelector('.player-1-panel').classList.remove('winner');
    //removing the CSS 'active' classfrom both player panels
    document.querySelector('.player-0-panel').classList.remove('active');
    document.querySelector('.player-1-panel').classList.remove('active');
    
    //we remove the active class from both '.player-0/1-panel's to be safe and make sure neither has it and then we will add it to the correct one below
    
    //adding the active class back to panel 0 to start a new game 
    document.querySelector('.player-0-panel').classList.add('active');
}



