/*
GAME RULES:

- The game has 2 players, playing in rounds
- In each turn, a player rolls a dice as many times as he whishes. Each result get added to his ROUND score
- BUT, if the player rolls a 1, all his ROUND score gets lost. After that, it's the next player's turn
- The player can choose to 'Hold', which means that his ROUND score gets added to his GLBAL score. After that, it's the next player's turn
- The first player to reach 100 points on GLOBAL score wins the game


//_----------______------------_______-------------_________---------_________

/*
YOUR 3 CHALLENGES
Change the game to follow these rules:

1. A player looses his ENTIRE score when he rolls two 6 in a row. After that, it's the next player's turn. (Hint: Always save the previous dice roll in a separate variable)
2. Add an input field to the HTML where players can set the winning score, so that they can change the predefined score of 100. (Hint: you can read that value with the .value property in JavaScript. This is a good oportunity to use google to figure this out :)
3. Add another dice to the game, so that there are two dices now. The player looses his current score when one of them is a 1. (Hint: you will need CSS to position the second dice, so take a look at the CSS code for the first one.)
*/



var scores, roundScore, activePlayer, gamePlaying;

//using a Statevariable: 'gamePlaying'-> tells us the condidtion of the system
//is our game playing yes or no?


init();

//for coding challenge part 1 
var lastDiceSix;

// the event listener for the dice roll button 
document.querySelector('.btn-roll').addEventListener('click', function(){
    //console.log(scores[activePlayer]);
    //state variable checker
    if(gamePlaying) {
        //Challenge 3: Adding 2 dice rolls 
            // 1. Random Number
        var dice1 = Math.floor(Math.random() *6) + 1;
        var dice2 = Math.floor(Math.random() *6) + 1;
        console.log('Dice: ' + [dice1, dice2, (dice1 + dice2)]);
        //2. Display the result
        document.getElementById('dice-1').style.display = 'block';
        document.getElementById('dice-2').style.display = 'block';
        document.getElementById('dice-1').src = 'dice-' + dice1 + '.png';
        document.getElementById('dice-2').src = 'dice-' + dice2 + '.png';
 

        //3. Update the round score IF the rolled number was NOT a 1
        if (dice1 !== 1 && dice2 !== 1) {
            //Add Score if anything but a 1 is rolled
            roundScore += (dice1 + dice2);
            document.querySelector('#current-' + activePlayer).textContent = roundScore;
        } else {
            //****-> Using the DRY principle, the above code could be shortened to the function call on line 66 because we have now created a function nextPlayer that does that same thing 
            nextPlayer();//Lec #8 
        }  
    }
    
});



// The event listener for the Hold Button '.btn-hold' 
document.querySelector('.btn-hold').addEventListener('click', function(){
    //state variable checker
    if(gamePlaying) {
        //Add Current score to GLOBAL score => (using the 'scores' array on the global object) 
        scores[activePlayer] += roundScore;
        lastDiceSix = false;

        // Update the UI, where are we writing our data to? => '#score-0', '#score-0'
        document.querySelector('#score-' + activePlayer).textContent = scores[activePlayer];
        
        //console.log('HoldButton: ' + scores[activePlayer]);
        
        var input = document.querySelector('.final-score').value;
        var winningScore;
        //all the values of Unedfined, 0, null, or "" are coerced to false (falsy)
        if(!input) {
            winningScore = 100;
        }else{
           winningScore = input;
            console.log(input); 
        }
        
    // Check if the player won the game
        // We could actually just copy and paste the code from above but...
        //We use the Don't Repeat Yourself (DRY) Principle -> implement new function
        if(scores[activePlayer] >= winningScore) {
            document.querySelector('#name-' + activePlayer).textContent = 'Winner!';

            //Optional Feature: hide the 'roll' and 'hold' buttons when the game has been won
            document.querySelector('.btn-roll').style.display = 'none'; //Lec #8
            document.querySelector('.btn-hold').style.display = 'none';//Lec #8

            document.getElementById('dice-1').style.display = 'none';
            document.getElementById('dice-2').style.display = 'none';

            //adjusting the player panels with the CSS class 'winner'
            document.querySelector('.player-'+activePlayer + '-panel').classList.add('winner');//Lec #8
            document.querySelector('.player-'+activePlayer + '-panel').classList.remove('active');//Lec #8

            //state variable changer
            gamePlaying = false;
        }else{
            nextPlayer();//Lec #8
        }//Lec #8
    }
    
    
    
    
});


//Creating this reusable function is an example of the DRY principle 
function nextPlayer(){
     // Next player: and delete round score if 1 is rolled 
        
        console.log('Was: '+ activePlayer);
        // using ternary operator _ ? _ : _ ; to decide the active player 
        activePlayer === 0 ? activePlayer = 1 : activePlayer = 0;
        roundScore = 0;
        lastDiceSix = false;
        console.log('Is Now: '+ activePlayer);
        //sets the 'current' id scores to 0 - as in their round score 
        document.getElementById('current-0').textContent = '0';
        document.getElementById('current-1').textContent = '0';
        
        
        //use classList.toggle() instead - it works like a light switch 
        document.querySelector('.player-0-panel').classList.toggle('active');
        document.querySelector('.player-1-panel').classList.toggle('active');
        
        
        // making the dice disappear after a 1 is rolled (only gone until the dice is rolled again though)
        document.getElementById('dice-1').style.display = 'none';
        document.getElementById('dice-2').style.display = 'none';
    
}//Lec #8


//LECTURE 9 -- Initializtion function (or INIT for short)
document.querySelector('.btn-new').addEventListener('click', init);


function init(){
    scores = [0,0];
    roundScore = 0;
    activePlayer = 0;
    gamePlaying = true;
    lastDiceSix = false;

    //when the page loads the dice doesn't appear right away (until rolldice is pushed)
    document.getElementById('dice-1').style.display = 'none';
    document.getElementById('dice-2').style.display = 'none';
    
    //specifically for the .btn-new class but makes sure these buttons are there when needed 
    document.querySelector('.btn-roll').style.display = 'initial'; 
    document.querySelector('.btn-hold').style.display = 'initial';

    // setting all scores to 0 when the program loads 
    document.getElementById('score-0').textContent = '0';
    document.getElementById('score-1').textContent = '0';
    document.getElementById('current-0').textContent = '0';
    document.getElementById('current-1').textContent = '0';
    
    //Set the names back (usually after a winner has occurred)
    document.getElementById('name-0').textContent = 'Player 1';
    document.getElementById('name-1').textContent = 'Player 2';
    
    //removing the CSS 'winner' class from the player panels
    document.querySelector('.player-0-panel').classList.remove('winner');
    document.querySelector('.player-1-panel').classList.remove('winner');
    //removing the CSS 'active' classfrom both player panels
    document.querySelector('.player-0-panel').classList.remove('active');
    document.querySelector('.player-1-panel').classList.remove('active');
    
    //we remove the active class from both '.player-0/1-panel's to be safe and make sure neither has it and then we will add it to the correct one below
    
    //adding the active class back to panel 0 to start a new game 
    document.querySelector('.player-0-panel').classList.add('active');
}



