// Lecture 95: let and const
//-------------------------------------------------
/*
//ES5
var name5 = 'Jane Smith';
var age5 = 23;
name5 = 'Jane Miller';
console.log(name5);

// ES6 -- instead of var we can now choose between const and let - const: stands for constant and is used to represend values that we don't want to change; let - is like the old var, meaning it is for values we wish to mutate later on.  
const name6 = 'Jane Smith';
let age6 = 23;
name6 = 'Jane Miller'; // results in an error because you can't change the value of a constant 
console.log(name6);
*/

//-------------------------------------------------

////functions decalred with let and const -- THEY ARE BLOCK SCOPED!!!
//// ES5 - var is accessible from outside the if statement 
//function driversLicense5(passedTest){
//    
//    if(passedTest) {
//        console.log(firstName);
//        var firstName = 'John';
//        var yearOfBirth = 1990;
//        
//    }
//    console.log(firstName + ', born in ' + yearOfBirth + ', is now officially allowed to drive a car.');
//}
//
//driversLicense5(true);
//
//// ES6 - let and const and not accessible outside of their block of code 
//function driversLicense6(passedTest){
//    //console.log(firstName); --> results in RefrenceError 'firstName is not defined'
//    let firstName;
//    const yearOfBirth = 1990;
//    
//    if(passedTest) {
//        firstName = 'John';
//        //console.log(firstName + ', born in ' + yearOfBirth + ', is now officially allowed to drive a car.');
//    }
//    console.log(firstName + ', born in ' + yearOfBirth + ', is now officially allowed to drive a car.');
//}
//
//driversLicense6(true);


//-------------------------------------------------


////Assigning values to variables using let vs. var
//
//// the i created in the global scope will not be affected by the for loop
//let i = 23;
//
//for(let i = 0; i < 5; i++){ 
//    console.log(i); // -> 0,1,2,3,4
//};
//
//console.log(i); // -> 23
//
//// the x variable created before the for loop will be affectd -- it will be mutated when x is assigned to 0 furing the first iteration.
//var x = 23;
//
//for(var x = 0; x < 5; x++){
//    console.log(x); // -> 0,1,2,3,4
//};
//
//console.log(x); // -> 5








// ####################################################################################

//Lecture 96: Blocks and IFFES
//-------------------------------------------------

//// ES6
//{
//    const a = 1;
//    let b = 2;
//    var c = 3;
//}
////console.log(a+b); // results in a RefrenceError: 'a is not defined'
//console.log(c);
//
//
////  ES5
//(function()  {
//    var c = 3;
// })();







// ####################################################################################

////Lecture 97: Strings in ES6/ES2015
////-------------------------------------------------
//
//let firstName = 'John';
//let lastName = 'Smith';
//const yearOfBirth = 1990;
//
//function calcAge(year){
//    return 2018 - year;
//}
//
////  ES5 - using + to concatenate variables and expressions with strings 
//console.log('This is ' + firstName + ' ' + lastName + '. He was born in ' + yearOfBirth + '. Today, he is ' + calcAge(yearOfBirth) + ' years old.');
//
////  ES6 - strings in backtics `` ==> telling JS we want to use template literal
//console.log(`This is ${firstName} ${lastName}. He was born in ${yearOfBirth}. Today, he is ${calcAge(yearOfBirth)} years old.`);
//
//
////-------------------------------------------------
//
//// New String Methods 
//const n = `${firstName} ${lastName}`;
//// .startswith
//console.log([n.startsWith('J'), n.startsWith('John'), n.startsWith('j')]); // results in [true, true, false]
//
//// .endswith
//console.log([n.endsWith('h'), n.endsWith('S'), n.endsWith('Smith')]); // results in [true, false, true]
//
//// .includes
//console.log([n.includes(' '), n.includes('z'), n.includes('oh')]); // results in [true, false, true]
//
//// .repeat [ES6, ES5];
//console.log([`${firstName} `.repeat(5), firstName.repeat(5)]); // using template literal then just regular dot notation 








// ####################################################################################
//
////Lecture 98: Arrow Functions: Basics 
////-------------------------------------------------
//
//
//const years = [1990, 1965, 1982, 1937];
//
//// ES5
//var ages5 = years.map(function(el) {
//    return 2018 - el;
//});
//console.log(ages5);
//
//// ES6
//let ages6 = years.map(el => 2018 - el);
//console.log(ages6);
//// for simple callback functions with only one return statement then the callback function can be represented as an arrow function where all we need is: 
//    // the argument : el, the operator : =>, and the return statement : 2016 - el
//
//// using arrow functions with template literal notation 
//ages6 = years.map((el, index) => `Age element ${index + 1}: ${2018 - el}.`)
//console.log(ages6);
//
//
//// creating variables inside of an arrow function 
//ages6 = years.map((el, index) => {
//    const now = new Date().getFullYear();
//    const age = now - el;
//    return `Age element ${index + 1}: ${age}.`    
//});
//console.log(ages6);






// ####################################################################################

//Lecture 99: Arrow Functions: Lexical 'This' Keyword 
//-----------------------------------------------------------

//Arrow functions do not have a this keyword - they only have a lexical this variable

// ES5
//var box5 = {
//    color: 'green',
//    position: 1,
//    clickMe: function() {
//        
//        var self = this;
//        
//        document.querySelector('.green').addEventListener('click', function() {
//            var str = 'This is box number ' + self.position + ' and it is ' + self.color;
//            alert(str);
//        });
//    }
//}
////box5.clickMe();
////---------------------------
//
//// ES6
//// how can we use arrow functions to avoid the above hackaround using 'var self = this'
//var box6 = {
//    color: 'green',
//    position: 1,
//    clickMe: function() {
//        
//        document.querySelector('.green').addEventListener('click', () => {
//            var str = 'This is box number ' + this.position + ' and it is ' + this.color;
//            alert(str);
//        });
//    }
//}
//box6.clickMe();

// use arrow functions when you need to preserve the value of the this keyword 

//---------------------------

// ES6 taking away the functiion keyword 

//var box66 = {
//    color: 'green',
//    position: 1,
//    clickMe: () =>  {
//        
//        document.querySelector('.green').addEventListener('click', () => {
//            var str = 'This is box number ' + this.position + ' and it is ' + this.color;
//            alert(str);
//        });
//    }
//}
//box66.clickMe();
// results with color and position being undefined 




//-----------------------------------------------------------
// working with Constructor Functions

//function Person(name){
//    this.name = name;
//}
//
//// ES5
//Person.prototype.myFriends5 = function(friends) {
//    
//    var arr = friends.map(function(el)
//        {
//            return this.name + ' is friends with ' + el;
//        }.bind(this));// adding .bind(this) points it at the new Person instance 
//    console.log(arr);
//}
//
//var friends = ['Bob', 'Jane', 'Mark'];
//new Person('John').myFriends5(friends);
//
//
//
//
//// ES6 - use an arrow function as the callback function in .map()
//Person.prototype.myFriends6 = function(friends) {
//    
//    let arr = friends.map(el => `${this.name} is friends with ${el}`);
//    console.log(arr);
//}
//
//new Person('Mike').myFriends6(friends);






// ####################################################################################

//Lecture 100: Destructuring
//-----------------------------------------------------------

////  ES5
//var john = ['John', 26];
////var name = john[0];
////var age = john[1];
//
//// ES6 - destructuring
//const [name, age] = ['John', 26]; // creates a constant called name and a constant called year where the data will be stored
//console.log(name);
//console.log(age);
//
////---------------------------
//
//const obj = {
//    firstName: 'John',
//    lastName: 'Smith'
//};
//
//const {firstName, lastName} = obj;
//console.log(firstName);
//console.log(lastName);
//
//
//const {firstName: a, lastName: b} = obj;
//console.log(a);
//console.log(b);
//
////---------------------------
//
//function calcAgeRetirement(year) {
//    const age = new Date().getFullYear() - year;
//    return [age, 65 - age];
//} //returns an array
//
////Use destructuring in order to store the array into different variables
//const [age2, retirement] = calcAgeRetirement(1995);
//console.log(age2);
//console.log(retirement);


// ####################################################################################

//Lecture 101: Arays in ES6 / ES2015
//-----------------------------------------------------------

//const boxes = document.querySelectorAll('.box');

// ES5
//var boxesArr5 = Array.prototype.slice.call(boxes);
//boxesArr5.forEach(function(cur) {
//    cur.style.backgroundColor = 'dodgerBlue';
//});

//// ES6 - basically just using an arrow function and shortening it down a lot 
//const boxesArr6 = Array.from(boxes);
////boxesArr6.forEach(cur => cur.style.backgroundColor = 'dodgerBlue');
//
//// shortening the above code even more ...
//Array.from(boxes).forEach(cur => cur.style.backgroundColor = 'dodgerBlue');
//
//////--------------------------- 
////  Loops
////  ES5 -- (works with the above ES5 code in this lecture)
////for(var i = 0; i < boxesArr5.length; i++){
////    if(boxesArr5[i].className === 'box blue') {
////        // if this item in the iteration of the loop has these class names then we move on
////        continue;
////    }
////    
////    boxesArr5[i].textContent = 'I changed to blue!';
////}
//
////  ES6 - use with the code above labeled under ES6 - need boxesArr6 to be active - only one of the lines making it 'dodgerBlue' is needed
//// Using: [.includes, .className]
//for (const cur of boxesArr6){
//    if(cur.className.includes('blue')){
//        continue;
//    }
//    cur.textContent = 'I changed to blue!';
//}
//
//
//
//////--------------------------- 
////  ES5
//var ages = [12, 17, 8, 21, 14, 11];
//
//var full = ages.map(function(cur){
//    return cur >= 18;
//});
//// show the array of booleans created from 'ages' 
//console.log(full);
////what point in the array does it return true? 
//console.log(full.indexOf(true));
//// how old the person is - retrieve the element from the array
//console.log(ages[full.indexOf(true)]);
//
//
//// ES6 
////using: findIndex
////return the index for the element in which the callback function returns true
//console.log(ages.findIndex(cur => (cur >= 18)));
//
////retrieve the element and not just the index
//console.log(ages.find(cur => (cur >= 18)));





// ####################################################################################

//Lecture 102: The Spread Operator 
//-----------------------------------------------------------

//function addFourAges (a, b, c, d) {
//    return a + b + c + d;
//}
//
//var sum1 = addFourAges(18, 30, 12, 21);
//
//console.log(sum1);
//
//
////  ES5 - using the .apply method 
//var ages = [18, 30, 12, 21];
//var sum2 = addFourAges.apply(null, ages);
//console.log(sum2);
//
//
////  ES6 - spread operator '...'
//const sum3 = addFourAges(...ages);
//console.log(sum3);
//
//// use cases
//
//const familySmith = ['John', 'Jane','Mark'];
//const familyMiller = ['Mary', 'Bob', 'Ann'];
////using the spread operator on the above arrays to create one larger array
//const bigFamily = [...familySmith, 'Lily', ...familyMiller];
//console.log(bigFamily); //["John", "Jane", "Mark", "Lily", "Mary", "Bob", "Ann"]
//
////////--------------------------- 
//
//const h = document.querySelector('h1');
//const boxes = document.querySelectorAll('.box');
//const all = [h, ...boxes];
////console.log(all); //Returns: [h1, div.box.green, div.box.blue, div.box.orange]
//
////for Each item in the array all corresponding objects will now have purple text 
//Array.from(all).forEach(cur => cur.style.color = 'purple');






// ####################################################################################

//Lecture 103: Rest Parameters 
//-----------------------------------------------------------
//Notes: 
/*
Rest Parameters: allow us to pass an aribitrary number of arguments into a function, and use those arguments in that function.
---> *Rest Parameters are the exact opposite of the spread operator.
    ---> ---> That is because: Spread Operator takes an array and basically transforms it into singal values.... While the rest parameters receive a couple of single values and transforms them into an array when we call them into a function with multiple parameters.  
*/

//// ES5 - USing: arguments
//function isFullAge5(){
//    //console.log(arguments);
//    var argsArr = Array.prototype.slice.call(arguments);
//    
//    argsArr.forEach(function(cur) {
//        console.log((2018 - cur) >= 18);
//    });
//}
//
////isFullAge5(1990, 1965, 2005, 1995, 2001);
////isFullAge5(1990, 1965, 2005, 1995, 2001, 1981, 1999, 2014);
//
//
////  ES6
//function isFullAge6(...years){
//    //console.log(years);
//    
//    years.forEach(cur => console.log((2018 - cur) >= 18));
//}
//
//
//isFullAge6(1990, 1965, 2005, 1995, 2001);


//-----------------------------------------------------------


//// ES5 - USing: adding an argument and using arguments
//function isFullAge5(limit){
//    console.log(arguments);
//    var argsArr = Array.prototype.slice.call(arguments, 1); // cuts off the first argument in the list and returns the rest as an array
//    console.log(argsArr);
//    
//    argsArr.forEach(function(cur) {
//        console.log((2018 - cur) >= limit);
//    });
//}
//
////isFullAge5(21, 1990, 1965, 2005, 1995, 2001);
////isFullAge5(1990, 1965, 2005, 1995, 2001, 1981, 1999, 2014);
//
//
////  ES6
//function isFullAge6(limit, ...years){
//    //console.log(years);
//    
//    years.forEach(cur => console.log((2018 - cur) >= limit));
//}
//
//
//isFullAge6(21,1990, 1965, 2005, 1995, 2001); //[T T F T F]





// ####################################################################################

//Lecture 104: Default Parameters 
//-----------------------------------------------------------
/*
Notes:
We use default parameters whenever we want one or more parameters of a function to be preset 

*/


//  ES5 //having a prameter return as undefined and making use of that 
//function SmithPerson(firstName, yearOfBirth, lastName, nationality){
//    
//    //if no lastName/nationality is given it automatically assigns 'Smith'/'American'
//    lastName === undefined ? lastName = 'Smith' : lastName;
//    nationality === undefined ? nationality = 'American' : nationality;
//
//    
//    this.firstName = firstName;
//    this.yearOfBirth = yearOfBirth;
//    this.lastName = lastName;
//    this.nationality = nationality;
//}



// ES6
//function SmithPerson(firstName, yearOfBirth, lastName = 'Smith', nationality = 'American'){
//    this.firstName = firstName;
//    this.yearOfBirth = yearOfBirth;
//    this.lastName = lastName;
//    this.nationality = nationality;
//}
//
//
//var john = new SmithPerson('John', 1990);
//console.log(john);
//var emily = new SmithPerson('Emily', 1983, 'Diaz', 'Spanish')
//console.log(emily); //Overwriting the default parameters










// ####################################################################################

//Lecture 105: Maps 
//-----------------------------------------------------------
/*
Maps can use any primitive values and even functions as keys

Methods: [set, has, get, delete, clear, size]
These are some methods that can be used on an instnace of Map() -- such as 'question' below -- 
-> these methods are some of the more common ones used to manipulate Maps 
*/

//const question = new Map();
//
//question.set('question', 'What is the official name of the latest major JavaScript Version?');
//question.set(1, 'ES5');
//question.set(2, 'ES6');
//question.set(3, 'ES2015'); //correct answer 
//question.set(4, 'ES7');
//question.set('correct', 3);
//question.set(true, 'Correct Answer :D');
//question.set(false, 'Wrong, please try again!');
//
////console.log(question.get('question'));
////console.log(question.size);
//
//if(question.has(4)) {
//    //question.delete(4);
//    //console.log('Answer 4 is here')
//}
//
//
////question.clear();
//
////----------------------------------------------
//// Maps are also Iterable so this means that we can loop through them (which we can't easily do with objects)
////Use the forEach property which is in the prototype property of all Map objects 
//
////question.forEach((value, key) => console.log(`this is ${key}, and it's set to ${value}`));
//
//// below is yet another case of destructuring 
//for (let [key, value] of question.entries()) {
//    
//    //only print value if the key is a number 
//    if( typeof(key) === 'number' ) {
//        console.log(`Answer ${key}: ${value}`)
//    }
//    
//}
//
////prompt user for an answer 
//const ans = parseInt(prompt('Write the correct answer'));
//
//console.log(question.get(ans === question.get('correct')));
//
///*
//Summary of Maps Lecture:
//    Reasons why Maps are better than Objects at creating Hash-Maps:
//        1. we can use anything as keys which opens up a lot of possibilities 
//        2. Maps are iterable, which makes it very easy to loop through them and manipulate data 
//        3. Easy to get the size of a Map using the size property
//        4. We can easily add and remove data from a Map 
//*/












// ####################################################################################

//Lecture 106: Classes 
//-----------------------------------------------------------
/*
Classes: One of the biggest editions to ES6 "Synthetic Sugar"
    - don't add anything new to the language just makes prototypal inheritance easier 
    - classes simply makie it easier to implement inheritance and to create objects based on blueprints
    
    - in ES5 these blueprints are called constructors 

*/


////  ES5
//var Person5 = function(name, yearOfBirth, job)  {
//    this.name = name;
//    this.yearOfBirth = yearOfBirth;
//    this.job = job;
//}
//
//Person5.prototype.calculateAge = function() {
//    var age = new Date().getFullYear - this.yearOfBirth;
//    console.log(age);
//}
//
//
//// instance of Person5
//var john5 = new Person5('John', 1990, 'teacher');
//console.log(john5);
//
//
//// ES6
//class Person6 {
//    constructor (name, yearOfBirth, job) {
//        this.name = name;
//        this.yearOfBirth = yearOfBirth;
//        this.job = job;
//    }
//    
//    calculateAge(){
//        var age = new Date().getFullYear - this.yearOfBirth;
//    }
//    
//    
//    //-----------------------------------
//    // Static Methods: are methods that are simply attached to the class but not inherited to the class instances 
//    //(not really helpful but he still wanted to show them to us)
//    static greeting(){
//        console.log('Hey There!');
//    }
//}
//
//
//const john6 = new Person6('John', 1990, 'teacher');
//console.log(john6);
//
//Person6.greeting();












// ####################################################################################

//Lecture 107: Classes With Subclasses
//-----------------------------------------------------------
/*Notes:
 ** prototype inheritance with classes **
    
    - using the Person Object/Class created in the previous lecture we will create a Subclass of Person called Athlete 

*/


//// ES5
//var Person5 = function(name, yearOfBirth, job)  {
//    this.name = name;
//    this.yearOfBirth = yearOfBirth;
//    this.job = job;
//}
//
//Person5.prototype.calculateAge = function() {
//    var age = new Date().getFullYear() - this.yearOfBirth;
//    console.log(age);
//}
//
//var Athlete5 = function(name, yearOfBirth, job, olympicGames, medals)  {
//    
//    Person5.call(this, name, yearOfBirth, job); //* this points to the new instance of Athlete5
//    this.olympicGames = olympicGames;
//    this.medals = medals;
//}
//
//
////Use Object.create to create the correct prototype chain.  Because Object.ceate allows us to manually set the prototype of an object (and we want the prototype of the Athlete to be the prootype of Person so they can be connected.) 
//Athlete5.prototype = Object.create(Person5.prototype);
//
//var johnAthlete5 = new Athlete5('John', 1990, 'swimmer', 3, 10);
//
//
//Athlete5.prototype.wonMedal = function(){
//    this.medals++;
//    console.log(this.medals);
//}
//
//
//
//johnAthlete5.calculateAge(); // we can use this method (even though it wasn't defined on the construtor) because we used Object.create to link the prototype chains 
//johnAthlete5.wonMedal();
//// Person5 = superclass , Athlete5 = Subclass 
//
//
//
//
//
//// ES6
//
////superclass 
//class Person6 {
//    constructor (name, yearOfBirth, job) {
//        this.name = name;
//        this.yearOfBirth = yearOfBirth;
//        this.job = job;
//    }
//    
//    calculateAge(){
//        var age = new Date().getFullYear() - this.yearOfBirth;
//        console.log(age);
//    }
//    
//
//}
//
////subclass
//class Athlete6 extends Person6 { // in the sub class we must say that it 'extends' the superclass 
//    constructor (name, yearOfBirth, job, olympicGames, medals) {
//        super(name, yearOfBirth, job);
//        this.olympicGames = olympicGames;
//        this.medals = medals;
//    }
//    
//    wonMedal() {
//        this.medals++;
//        console.log(this.medals);
//    }
//}
//
//const johnAthlete6 = new Athlete6('John', 1990, 'swimmer', 3, 10);
//
//johnAthlete6.wonMedal();
//johnAthlete6.calculateAge();




//####################################################################################
//####################################################################################
/////////////////////////////////
// CODING CHALLENGE

/*

Suppose that you're working in a small town administration, and you're in charge of two town elements:
1. Parks
2. Streets

It's a very small town, so right now there are only 3 parks and 4 streets. All parks and streets have a name and a build year.

At an end-of-year meeting, your boss wants a final report with the following:
1. Tree density of each park in the town (forumla: number of trees/park area)
2. Average age of each town's park (forumla: sum of all ages/number of parks)
3. The name of the park that has more than 1000 trees
4. Total and average length of the town's streets
5. Size classification of all streets: tiny/small/normal/big/huge. If the size is unknown, the default is normal

All the report data should be printed to the console.

HINT: Use some of the ES6 features: classes, subclasses, template strings, default parameters, maps, arrow functions, destructuring, etc.

*/

//There are two primary elements: Parks and Streets
    // create a class for any item -- both have a name and a build year 

//create main superclass
class Element {
    constructor(name, buildYear){
        this.name = name;
        this.buildYear = buildYear;
    }
}


//Parks Subclass: [parameters: total trees, area of the park; inherits: name, build year]
class Park extends Element{
    constructor(name, buildYear,parkArea , treeCount){
        super(name, buildYear);
        this.treeCount = treeCount;
        this.parkArea = parkArea;
    }
    
    //1. Tree density 
    treeDensity(){
        console.log(`The Tree Density of ${this.name} is ${(this.treeCount / this.parkArea)} trees per square Km`);
    }
    
    
    
}


//Streets Subclass: [parameters: length, size (default = normal); inherits: name, build year]
class Street extends Element{
    constructor(name, buildYear, length, size = 'normal'){
        super(name, buildYear);
        this.length = length;
        this.size = size;
    }

    classifyStreet () {
        const classification = new Map();
        classification.set(1, 'tiny');
        classification.set(2, 'small');
        classification.set(3, 'normal');
        classification.set(4, 'big');
        classification.set(5, 'huge');
        console.log(`${this.name}, build in ${this.buildYear}, is a ${classification.get(this.size)} street.`);
    }
}




//******************TEST CASES***************
const allParks = [new Park('Green Park', 1987, 0.2, 215),
                 new Park('National Park', 1894, 2.9, 3541),
                 new Park('Oak Park', 1953, 0.4, 949)];

const allStreets = [new Street('Ocean Avenue', 1999, 1.1, 4),
                   new Street('Evergreen Street', 2008, 2.7, 2),
                   new Street('4th Street', 2015, 0.8),
                   new Street('Sunset Boulevard', 1982, 2.5, 5)];


function calc(arr) {
    
    const sum = arr.reduce((prev, cur, index) => prev + cur, 0);
    
    return [sum, sum / arr.length];
    
}


function reportParks(p) {
    
    console.log('-----PARKS REPORT-----');
    
    // Density
    p.forEach(el => el.treeDensity());
    
    // Average age
    const ages = p.map(el => new Date().getFullYear() - el.buildYear);
    const [totalAge, avgAge] = calc(ages);
    console.log(`Our ${p.length} parks have an average of ${avgAge} years.`);
    
    // Which park has more than 1000 trees
    const i = p.map(el => el.treeCount).findIndex(el => el >= 1000);
    console.log(`${p[i].name} has more than 1000 trees.`);
    
}


function reportStreets(s) {
    
    console.log('-----STREETS REPORT-----');
    
    //Total and average length of the town's streets
    const [totalLength, avgLength] = calc(s.map(el => el.length));
    console.log(`Our ${s.length} streets have a total length of ${totalLength} km, with an average of ${avgLength} km.`);
    
    // CLassify sizes
    s.forEach(el => el.classifyStreet());
}

reportParks(allParks);
reportStreets(allStreets);