export default class Likes { 
    
    constructor() {
        this.likes = [];
    }
    
    
    addLike(id, title, author, img) {
        
        const like = {id, title, author, img };
        
        this.likes.push(like);
        
        
        // Persist data in localStorage
        this.persistData();
        
        
        return like;
    }
    
    //Delete a liked item from the this.likes array
    deleteLike(id) {
        const index = this.likes.findIndex(el => el,id === id);
        //^ set index equal to the index of the id in the likes array (with this we have the index where the desired item is located)
        
        
        //SPlice vs. SLice
        // [2 ,4, 8] splice(1, 1) -> return 4, original array is [2, 8]
        // [2 ,4, 8] slice(1, 1) -> return 4, original array is [2, 4, 8]
        
        this.likes.splice(index, 1);
        //^start at the position where the item is located and we take out one element, removing it from the array.
        
        
        // Persist data in localStorage
        this.persistData();
        
    }
    
    isLiked(id) {
        //^ to test if we have an item in our this.likes array that matches the id that is passed in (if it's in the array already or not)
        
        return this.likes.findIndex(el => el.id === id) !== -1;
        //^ if we cannot find any item with the id we passed in it will return -1 and will return false, but if it is in there it will return true
    }
    
    getNumLikes() {
        return this.likes.length;
    }
    
    persistData() {
        localStorage.setItem('likes', JSON.stringify(this.likes));
    }
    
    readStorage() {
        const storage = JSON.parse(localStorage.getItem('likes'));
        //^ will return null if it doesn't have key looking for 
        
        if(storage) this.likes = storage;
        //^ restore likes from the localStorage back into this.likes
        
    }
}