import uniqid from 'uniqid';
//^ a small library that will create uniqu IDs for us: "it will always create unique id's based on the current time, process and machine name.

export default class List {
    constructor() {
        this.items = [];
        //all the items in the list will be stored in this property which is the this.items array
    }
    
    //Methods:
    
    
    //Add the item to the list, always with the 3 parameters.
    addItem (count, unit, ingredient) {
        const item = {
            id: uniqid(),
            //^ how we assign the unique id to each new item added
            count,
            unit,
            ingredient
        }
        this.items.push(item);
        //^just pushes the new item to the array
        return item;
    }
    
    
    //Deleting an item from the items array (based on the id)
    deleteItem(id) {
        
        const index = this.items.findIndex(el => el,id === id);
        //^ set index equal to the index of the id in the items array (with this we have the index where the desired item is located)
        
        
        //SPlice vs. SLice
        // [2 ,4, 8] splice(1, 1) -> return 4, original array is [2, 8]
        // [2 ,4, 8] slice(1, 1) -> return 4, original array is [2, 4, 8]
        
        this.items.splice(index, 1);
        //^start at the position where the item is located and we take out one element, removing it from the array.
    }
    
    
    //Updating the count of the element we want to manipulate 
    updateCount(id, newCount) {
        //Pass in the id and the new count of the object
        
        this.items.find(el => el.id === id).count = newCount;
        //find the element which has as the element id, the one we pass in.  THen we return the Object and change the count property on it. (This is using ES6)
    }
    
    
    //Closing bracket for List Class
}