import {elements} from './base';
import {limitRecipeTitle} from './searchView';

export const toggleLikeBtn = isLiked => {
    
    const iconString = isLiked ? 'icon-heart' : 'icon-heart-outlined';
    //^using the ternary operator to assign which one to use and assign to iconString
    
    document.querySelector('.recipe__love use').setAttribute('href', `img/icons.svg#${iconString}`);
    //^ set the attribute of the <use></use> tag in the .recipe__love class and set the attribute to the one assigned to iconString
    
    // icons.svg#icon-heart-outlined
};


export const toggleLikeMenu = numLikes => {
    //^based on numLikes we know whether or not to show the likes menu
    
    elements.likesMenu.style.visibility = numLikes > 0 ? 'visible' : 'hidden';
    //^ use ternary operator to toggle the menu 
};


export const renderLike = like => {
    
    const markup = `
    <li>
        <a class="likes__link" href="#${like.id}">

            <figure class="likes__fig">

                <img src="${like.img}" alt="${like.title}">

            </figure>

            <div class="likes__data">

                <h4 class="likes__name">${limitRecipeTitle(like.title)}</h4>

                <p class="likes__author">${like.author}</p>

            </div>
        </a>
    </li>
`;
    
    elements.likesList.insertAdjacentHTML('beforeend', markup);
    
};


export const deleteLike = id => {
    
    const el = document.querySelector(`.likes__link[href*="${id}"]`).parentElement;
    
    //test if selection was successful
    if(el) el.parentElement.removeChild(el);
    //^ if there is an element then we move up to the parent element and remove the child
    
};