import { elements } from './base';


// this func will render the list items
export const renderItem = item => {
  const markup = `
    <li class="shopping__item" data-itemid=${item.id}>

        <div class="shopping__count">

            <input type="number" value="${item.count}" step="${item.count}" class="shopping__count-value">

            <p>${item.unit}</p>

        </div>

        <p class="shopping__description">${item.ingredient}</p>

        <button class="shopping__delete btn-tiny">
            <svg>
                <use href="img/icons.svg#icon-circle-with-cross"></use>
            </svg>
        </button>

    </li>
`;
    
    elements.shopping.insertAdjacentHTML('beforeend', markup);
    //^inserts this markup to the html - and we do it beforeend so that they are displayed one after another.
}

//this func will delete the list items based on the id inputed 
export const deleteItem = id => {
    
    const item = document.querySelector(`[data-itemid="${id}"]`);
    //^select the element we want to delete based on the id ( the brackets are the CSS attribute selector) -- because of the id we pass in, we will be able to select that exact element because we attach the id to he element in the first line of the markup
    
    if(item) item.parentElement.removeChild(item);
    //^We have to move up to the parent so we can then remove the child, but only if there is an item
};

